<script lang="ts">
  import { expandedSpanId, type Log, organizations } from '$lib';
  import { onMount } from 'svelte';

  export let log: Log;

  const formatter = new Intl.DateTimeFormat('nl-NL', {
    year: 'numeric',
    month: '2-digit',
    day: '2-digit',
    hour: '2-digit',
    minute: '2-digit',
    second: '2-digit',
  });

  const durationFormatter = new Intl.NumberFormat('nl-NL', {
    style: 'decimal',
    maximumFractionDigits: 0,
  });

  // Close the expanded activity details when clicked outside
  let activityElement: HTMLDivElement;

  function handleClickOutside(event: MouseEvent) {
    if (
      $expandedSpanId === log.log.spanId &&
      activityElement &&
      !activityElement.contains(event.target as Node)
    ) {
      expandedSpanId.set(null);
    }
  }

  onMount(() => {
    document.addEventListener('click', handleClickOutside);

    // When the component is unloaded, Clean up the event listener
    return () => {
      document.removeEventListener('click', handleClickOutside);
    };
  });

  function containsAlgorithm(): boolean {
    let tags = log.log['tags'];
    if (tags) {
      return Object.keys(tags).some((key) => {
        if (key.startsWith('dpl.algoritmes')) {
          return true;
        }
      });
    }
    return false;
  }
</script>

<li class="row-{$organizations.indexOf(log.log.organization)}">
  <div class="row">
    <div class="organization">{log.log.organization}</div>
    <div class="activity" bind:this={activityElement}>
      {log.log.processingActivity || 'Onbekend'}
      <button
        class="info"
        on:click={() => {
          expandedSpanId.set($expandedSpanId === log.log.spanId ? null : log.log.spanId);
        }}
        type="button"
        ><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
          ><g
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            ><path d="M3 12a9 9 0 1 0 18 0a9 9 0 0 0-18 0m9-3h.01" /><path d="M11 12h1v4h1" /></g
          ></svg
        >
      </button>
      {#if $expandedSpanId === log.log.spanId}
        <div class="details">
          <h4>Mogelijk verwerkte persoonsgegevens:</h4>
          <ul>
            {#each log.log.personalData as personalData}
              <li>{personalData}</li>
            {/each}
          </ul>
        </div>
      {/if}
    </div>
    <div class="time">
      <span>{formatter.format(new Date(log.log.startedAt))}</span>
      <span>{durationFormatter.format(log.log.duration / 1000)} ms</span>
    </div>
  </div>

  {#if log.children.length > 0}
    <ul>
      {#each log.children as child}
        <svelte:self log={child} />
      {/each}
    </ul>
  {/if}
</li>
